/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
#include "stdlib.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

int A[4] = {1, 2, 3, 4};
int *PA;
void __e_acsl_globals_init(void)
{
  static char __e_acsl_already_run = 0;
  if (! __e_acsl_already_run) {
    __e_acsl_already_run = 1;
    __e_acsl_store_block((void *)(& PA),(size_t)8);
    __e_acsl_full_init((void *)(& PA));
    __e_acsl_store_block((void *)(A),(size_t)16);
    __e_acsl_full_init((void *)(& A));
  }
  return;
}

void __e_acsl_globals_clean(void)
{
  __e_acsl_delete_block((void *)(& PA));
  __e_acsl_delete_block((void *)(A));
  return;
}

int main(void)
{
  int __retres;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  __e_acsl_globals_init();
  PA = (int *)(& A);
  {
    unsigned long __gen_e_acsl_offset;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"(int *)A",
                                 (void *)(A));
    __gen_e_acsl_offset = __e_acsl_offset((void *)(A));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "\\offset((int *)A)",0,
                                   __gen_e_acsl_offset);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\offset((int *)A) == 0";
    __gen_e_acsl_assert_data.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 13;
    __e_acsl_assert(__gen_e_acsl_offset == 0UL,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \offset((int *)A) == 0; */ ;
  {
    unsigned long __gen_e_acsl_offset_2;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"&A[3]",
                                 (void *)(& A[3]));
    __gen_e_acsl_offset_2 = __e_acsl_offset((void *)(& A[3]));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "\\offset(&A[3])",0,__gen_e_acsl_offset_2);
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\offset(&A[3]) == 12";
    __gen_e_acsl_assert_data_2.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_2.fct = "main";
    __gen_e_acsl_assert_data_2.line = 14;
    __e_acsl_assert(__gen_e_acsl_offset_2 == 12UL,
                    & __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \offset(&A[3]) == 12; */ ;
  {
    unsigned long __gen_e_acsl_offset_3;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"PA",
                                 (void *)PA);
    __gen_e_acsl_offset_3 = __e_acsl_offset((void *)PA);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                   "\\offset(PA)",0,__gen_e_acsl_offset_3);
    __gen_e_acsl_assert_data_3.blocking = 1;
    __gen_e_acsl_assert_data_3.kind = "Assertion";
    __gen_e_acsl_assert_data_3.pred_txt = "\\offset(PA) == 0";
    __gen_e_acsl_assert_data_3.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_3.fct = "main";
    __gen_e_acsl_assert_data_3.line = 15;
    __e_acsl_assert(__gen_e_acsl_offset_3 == 0UL,
                    & __gen_e_acsl_assert_data_3);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
  }
  /*@ assert \offset(PA) == 0; */ ;
  PA ++;
  {
    unsigned long __gen_e_acsl_offset_4;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_4,"PA",
                                 (void *)PA);
    __gen_e_acsl_offset_4 = __e_acsl_offset((void *)(PA + 1));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_4,
                                   "\\offset(PA + 1)",0,
                                   __gen_e_acsl_offset_4);
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "\\offset(PA + 1) == 8";
    __gen_e_acsl_assert_data_4.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_4.fct = "main";
    __gen_e_acsl_assert_data_4.line = 17;
    __e_acsl_assert(__gen_e_acsl_offset_4 == 8UL,
                    & __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  /*@ assert \offset(PA + 1) == 8; */ ;
  int a[4] = {1, 2, 3, 4};
  __e_acsl_store_block((void *)(a),(size_t)16);
  __e_acsl_full_init((void *)(& a));
  {
    unsigned long __gen_e_acsl_offset_5;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_5 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"(int *)a",
                                 (void *)(a));
    __gen_e_acsl_offset_5 = __e_acsl_offset((void *)(a));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                   "\\offset((int *)a)",0,
                                   __gen_e_acsl_offset_5);
    __gen_e_acsl_assert_data_5.blocking = 1;
    __gen_e_acsl_assert_data_5.kind = "Assertion";
    __gen_e_acsl_assert_data_5.pred_txt = "\\offset((int *)a) == 0";
    __gen_e_acsl_assert_data_5.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_5.fct = "main";
    __gen_e_acsl_assert_data_5.line = 21;
    __e_acsl_assert(__gen_e_acsl_offset_5 == 0UL,
                    & __gen_e_acsl_assert_data_5);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_5);
  }
  /*@ assert \offset((int *)a) == 0; */ ;
  {
    unsigned long __gen_e_acsl_offset_6;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_6 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_6,"&a[1]",
                                 (void *)(& a[1]));
    __gen_e_acsl_offset_6 = __e_acsl_offset((void *)(& a[1]));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_6,
                                   "\\offset(&a[1])",0,__gen_e_acsl_offset_6);
    __gen_e_acsl_assert_data_6.blocking = 1;
    __gen_e_acsl_assert_data_6.kind = "Assertion";
    __gen_e_acsl_assert_data_6.pred_txt = "\\offset(&a[1]) == 4";
    __gen_e_acsl_assert_data_6.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_6.fct = "main";
    __gen_e_acsl_assert_data_6.line = 22;
    __e_acsl_assert(__gen_e_acsl_offset_6 == 4UL,
                    & __gen_e_acsl_assert_data_6);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_6);
  }
  /*@ assert \offset(&a[1]) == 4; */ ;
  {
    unsigned long __gen_e_acsl_offset_7;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_7 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_7,"&a[3]",
                                 (void *)(& a[3]));
    __gen_e_acsl_offset_7 = __e_acsl_offset((void *)(& a[3]));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_7,
                                   "\\offset(&a[3])",0,__gen_e_acsl_offset_7);
    __gen_e_acsl_assert_data_7.blocking = 1;
    __gen_e_acsl_assert_data_7.kind = "Assertion";
    __gen_e_acsl_assert_data_7.pred_txt = "\\offset(&a[3]) == 12";
    __gen_e_acsl_assert_data_7.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_7.fct = "main";
    __gen_e_acsl_assert_data_7.line = 23;
    __e_acsl_assert(__gen_e_acsl_offset_7 == 12UL,
                    & __gen_e_acsl_assert_data_7);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_7);
  }
  /*@ assert \offset(&a[3]) == 12; */ ;
  long l = (long)4;
  __e_acsl_store_block((void *)(& l),(size_t)8);
  __e_acsl_full_init((void *)(& l));
  char *pl = (char *)(& l);
  __e_acsl_store_block((void *)(& pl),(size_t)8);
  __e_acsl_full_init((void *)(& pl));
  {
    unsigned long __gen_e_acsl_offset_8;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_8 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_8,"&l",
                                 (void *)(& l));
    __gen_e_acsl_offset_8 = __e_acsl_offset((void *)(& l));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_8,
                                   "\\offset(&l)",0,__gen_e_acsl_offset_8);
    __gen_e_acsl_assert_data_8.blocking = 1;
    __gen_e_acsl_assert_data_8.kind = "Assertion";
    __gen_e_acsl_assert_data_8.pred_txt = "\\offset(&l) == 0";
    __gen_e_acsl_assert_data_8.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_8.fct = "main";
    __gen_e_acsl_assert_data_8.line = 28;
    __e_acsl_assert(__gen_e_acsl_offset_8 == 0UL,
                    & __gen_e_acsl_assert_data_8);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_8);
  }
  /*@ assert \offset(&l) == 0; */ ;
  {
    unsigned long __gen_e_acsl_offset_9;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_9 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_9,"pl",
                                 (void *)pl);
    __gen_e_acsl_offset_9 = __e_acsl_offset((void *)pl);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_9,
                                   "\\offset(pl)",0,__gen_e_acsl_offset_9);
    __gen_e_acsl_assert_data_9.blocking = 1;
    __gen_e_acsl_assert_data_9.kind = "Assertion";
    __gen_e_acsl_assert_data_9.pred_txt = "\\offset(pl) == 0";
    __gen_e_acsl_assert_data_9.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_9.fct = "main";
    __gen_e_acsl_assert_data_9.line = 29;
    __e_acsl_assert(__gen_e_acsl_offset_9 == 0UL,
                    & __gen_e_acsl_assert_data_9);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_9);
  }
  /*@ assert \offset(pl) == 0; */ ;
  {
    unsigned long __gen_e_acsl_offset_10;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_10 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_10,"pl",
                                 (void *)pl);
    __gen_e_acsl_offset_10 = __e_acsl_offset((void *)(pl + 1));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_10,
                                   "\\offset(pl + 1)",0,
                                   __gen_e_acsl_offset_10);
    __gen_e_acsl_assert_data_10.blocking = 1;
    __gen_e_acsl_assert_data_10.kind = "Assertion";
    __gen_e_acsl_assert_data_10.pred_txt = "\\offset(pl + 1) == 1";
    __gen_e_acsl_assert_data_10.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_10.fct = "main";
    __gen_e_acsl_assert_data_10.line = 30;
    __e_acsl_assert(__gen_e_acsl_offset_10 == 1UL,
                    & __gen_e_acsl_assert_data_10);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_10);
  }
  /*@ assert \offset(pl + 1) == 1; */ ;
  {
    unsigned long __gen_e_acsl_offset_11;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_11 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_11,"pl",
                                 (void *)pl);
    __gen_e_acsl_offset_11 = __e_acsl_offset((void *)(pl + 7));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_11,
                                   "\\offset(pl + 7)",0,
                                   __gen_e_acsl_offset_11);
    __gen_e_acsl_assert_data_11.blocking = 1;
    __gen_e_acsl_assert_data_11.kind = "Assertion";
    __gen_e_acsl_assert_data_11.pred_txt = "\\offset(pl + 7) == 7";
    __gen_e_acsl_assert_data_11.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_11.fct = "main";
    __gen_e_acsl_assert_data_11.line = 31;
    __e_acsl_assert(__gen_e_acsl_offset_11 == 7UL,
                    & __gen_e_acsl_assert_data_11);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_11);
  }
  /*@ assert \offset(pl + 7) == 7; */ ;
  int *pi = (int *)(& l);
  __e_acsl_store_block((void *)(& pi),(size_t)8);
  __e_acsl_full_init((void *)(& pi));
  {
    unsigned long __gen_e_acsl_offset_12;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_12 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_12,"pi",
                                 (void *)pi);
    __gen_e_acsl_offset_12 = __e_acsl_offset((void *)pi);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_12,
                                   "\\offset(pi)",0,__gen_e_acsl_offset_12);
    __gen_e_acsl_assert_data_12.blocking = 1;
    __gen_e_acsl_assert_data_12.kind = "Assertion";
    __gen_e_acsl_assert_data_12.pred_txt = "\\offset(pi) == 0";
    __gen_e_acsl_assert_data_12.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_12.fct = "main";
    __gen_e_acsl_assert_data_12.line = 33;
    __e_acsl_assert(__gen_e_acsl_offset_12 == 0UL,
                    & __gen_e_acsl_assert_data_12);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_12);
  }
  /*@ assert \offset(pi) == 0; */ ;
  __e_acsl_full_init((void *)(& pi));
  pi ++;
  {
    unsigned long __gen_e_acsl_offset_13;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_13 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_13,"pi",
                                 (void *)pi);
    __gen_e_acsl_offset_13 = __e_acsl_offset((void *)pi);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_13,
                                   "\\offset(pi)",0,__gen_e_acsl_offset_13);
    __gen_e_acsl_assert_data_13.blocking = 1;
    __gen_e_acsl_assert_data_13.kind = "Assertion";
    __gen_e_acsl_assert_data_13.pred_txt = "\\offset(pi) == 4";
    __gen_e_acsl_assert_data_13.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_13.fct = "main";
    __gen_e_acsl_assert_data_13.line = 35;
    __e_acsl_assert(__gen_e_acsl_offset_13 == 4UL,
                    & __gen_e_acsl_assert_data_13);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_13);
  }
  /*@ assert \offset(pi) == 4; */ ;
  char *p = malloc((unsigned long)12);
  __e_acsl_store_block((void *)(& p),(size_t)8);
  __e_acsl_full_init((void *)(& p));
  {
    unsigned long __gen_e_acsl_offset_14;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_14 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_14,"p",(void *)p);
    __gen_e_acsl_offset_14 = __e_acsl_offset((void *)p);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_14,
                                   "\\offset(p)",0,__gen_e_acsl_offset_14);
    __gen_e_acsl_assert_data_14.blocking = 1;
    __gen_e_acsl_assert_data_14.kind = "Assertion";
    __gen_e_acsl_assert_data_14.pred_txt = "\\offset(p) == 0";
    __gen_e_acsl_assert_data_14.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_14.fct = "main";
    __gen_e_acsl_assert_data_14.line = 39;
    __e_acsl_assert(__gen_e_acsl_offset_14 == 0UL,
                    & __gen_e_acsl_assert_data_14);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_14);
  }
  /*@ assert \offset(p) == 0; */ ;
  {
    unsigned long __gen_e_acsl_offset_15;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_15 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_15,"p",(void *)p);
    __gen_e_acsl_offset_15 = __e_acsl_offset((void *)(p + 1));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_15,
                                   "\\offset(p + 1)",0,
                                   __gen_e_acsl_offset_15);
    __gen_e_acsl_assert_data_15.blocking = 1;
    __gen_e_acsl_assert_data_15.kind = "Assertion";
    __gen_e_acsl_assert_data_15.pred_txt = "\\offset(p + 1) == 1";
    __gen_e_acsl_assert_data_15.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_15.fct = "main";
    __gen_e_acsl_assert_data_15.line = 40;
    __e_acsl_assert(__gen_e_acsl_offset_15 == 1UL,
                    & __gen_e_acsl_assert_data_15);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_15);
  }
  /*@ assert \offset(p + 1) == 1; */ ;
  {
    unsigned long __gen_e_acsl_offset_16;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_16 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_16,"p",(void *)p);
    __gen_e_acsl_offset_16 = __e_acsl_offset((void *)(p + 11));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_16,
                                   "\\offset(p + 11)",0,
                                   __gen_e_acsl_offset_16);
    __gen_e_acsl_assert_data_16.blocking = 1;
    __gen_e_acsl_assert_data_16.kind = "Assertion";
    __gen_e_acsl_assert_data_16.pred_txt = "\\offset(p + 11) == 11";
    __gen_e_acsl_assert_data_16.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_16.fct = "main";
    __gen_e_acsl_assert_data_16.line = 41;
    __e_acsl_assert(__gen_e_acsl_offset_16 == 11UL,
                    & __gen_e_acsl_assert_data_16);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_16);
  }
  /*@ assert \offset(p + 11) == 11; */ ;
  __e_acsl_full_init((void *)(& p));
  p += 5;
  {
    unsigned long __gen_e_acsl_offset_17;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_17 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_17,"p",(void *)p);
    __gen_e_acsl_offset_17 = __e_acsl_offset((void *)(p + 5));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_17,
                                   "\\offset(p + 5)",0,
                                   __gen_e_acsl_offset_17);
    __gen_e_acsl_assert_data_17.blocking = 1;
    __gen_e_acsl_assert_data_17.kind = "Assertion";
    __gen_e_acsl_assert_data_17.pred_txt = "\\offset(p + 5) == 10";
    __gen_e_acsl_assert_data_17.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_17.fct = "main";
    __gen_e_acsl_assert_data_17.line = 43;
    __e_acsl_assert(__gen_e_acsl_offset_17 == 10UL,
                    & __gen_e_acsl_assert_data_17);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_17);
  }
  /*@ assert \offset(p + 5) == 10; */ ;
  {
    unsigned long __gen_e_acsl_offset_18;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_18 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_18,"p",(void *)p);
    __gen_e_acsl_offset_18 = __e_acsl_offset((void *)(p - 5));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_18,
                                   "\\offset(p - 5)",0,
                                   __gen_e_acsl_offset_18);
    __gen_e_acsl_assert_data_18.blocking = 1;
    __gen_e_acsl_assert_data_18.kind = "Assertion";
    __gen_e_acsl_assert_data_18.pred_txt = "\\offset(p - 5) == 0";
    __gen_e_acsl_assert_data_18.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_18.fct = "main";
    __gen_e_acsl_assert_data_18.line = 44;
    __e_acsl_assert(__gen_e_acsl_offset_18 == 0UL,
                    & __gen_e_acsl_assert_data_18);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_18);
  }
  /*@ assert \offset(p - 5) == 0; */ ;
  long *q = malloc((unsigned long)30 * sizeof(long));
  __e_acsl_store_block((void *)(& q),(size_t)8);
  __e_acsl_full_init((void *)(& q));
  {
    unsigned long __gen_e_acsl_offset_19;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_19 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_19,"q",(void *)q);
    __gen_e_acsl_offset_19 = __e_acsl_offset((void *)q);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_19,
                                   "\\offset(q)",0,__gen_e_acsl_offset_19);
    __gen_e_acsl_assert_data_19.blocking = 1;
    __gen_e_acsl_assert_data_19.kind = "Assertion";
    __gen_e_acsl_assert_data_19.pred_txt = "\\offset(q) == 0";
    __gen_e_acsl_assert_data_19.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_19.fct = "main";
    __gen_e_acsl_assert_data_19.line = 49;
    __e_acsl_assert(__gen_e_acsl_offset_19 == 0UL,
                    & __gen_e_acsl_assert_data_19);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_19);
  }
  /*@ assert \offset(q) == 0; */ ;
  __e_acsl_full_init((void *)(& q));
  q ++;
  {
    unsigned long __gen_e_acsl_offset_20;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_20 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_20,"q",(void *)q);
    __gen_e_acsl_offset_20 = __e_acsl_offset((void *)q);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_20,
                                   "\\offset(q)",0,__gen_e_acsl_offset_20);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_20,
                                 "sizeof(long)",0,8);
    __gen_e_acsl_assert_data_20.blocking = 1;
    __gen_e_acsl_assert_data_20.kind = "Assertion";
    __gen_e_acsl_assert_data_20.pred_txt = "\\offset(q) == sizeof(long)";
    __gen_e_acsl_assert_data_20.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_20.fct = "main";
    __gen_e_acsl_assert_data_20.line = 51;
    __e_acsl_assert(__gen_e_acsl_offset_20 == 8UL,
                    & __gen_e_acsl_assert_data_20);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_20);
  }
  /*@ assert \offset(q) == sizeof(long); */ ;
  __e_acsl_full_init((void *)(& q));
  q += 2;
  {
    unsigned long __gen_e_acsl_offset_21;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_21 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_21,"q",(void *)q);
    __gen_e_acsl_offset_21 = __e_acsl_offset((void *)q);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_21,
                                   "\\offset(q)",0,__gen_e_acsl_offset_21);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_21,
                                 "sizeof(long)",0,8);
    __gen_e_acsl_assert_data_21.blocking = 1;
    __gen_e_acsl_assert_data_21.kind = "Assertion";
    __gen_e_acsl_assert_data_21.pred_txt = "\\offset(q) == sizeof(long) * 3";
    __gen_e_acsl_assert_data_21.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_21.fct = "main";
    __gen_e_acsl_assert_data_21.line = 53;
    __e_acsl_assert(__gen_e_acsl_offset_21 == 24UL,
                    & __gen_e_acsl_assert_data_21);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_21);
  }
  /*@ assert \offset(q) == sizeof(long) * 3; */ ;
  __e_acsl_full_init((void *)(& q));
  q += 4;
  {
    unsigned long __gen_e_acsl_offset_22;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_22 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_22,"q",(void *)q);
    __gen_e_acsl_offset_22 = __e_acsl_offset((void *)q);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_22,
                                   "\\offset(q)",0,__gen_e_acsl_offset_22);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_22,
                                 "sizeof(long)",0,8);
    __gen_e_acsl_assert_data_22.blocking = 1;
    __gen_e_acsl_assert_data_22.kind = "Assertion";
    __gen_e_acsl_assert_data_22.pred_txt = "\\offset(q) == sizeof(long) * 7";
    __gen_e_acsl_assert_data_22.file = "tests/memory/offset.c";
    __gen_e_acsl_assert_data_22.fct = "main";
    __gen_e_acsl_assert_data_22.line = 55;
    __e_acsl_assert(__gen_e_acsl_offset_22 == 56UL,
                    & __gen_e_acsl_assert_data_22);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_22);
  }
  /*@ assert \offset(q) == sizeof(long) * 7; */ ;
  __retres = 0;
  __e_acsl_delete_block((void *)(& q));
  __e_acsl_delete_block((void *)(& p));
  __e_acsl_delete_block((void *)(& pi));
  __e_acsl_delete_block((void *)(& pl));
  __e_acsl_delete_block((void *)(& l));
  __e_acsl_delete_block((void *)(a));
  __e_acsl_globals_clean();
  __e_acsl_memory_clean();
  return __retres;
}


